Index: /trunk/expressoCalendar/setup/default_records.inc.php
===================================================================
--- /trunk/expressoCalendar/setup/default_records.inc.php	(revision 5514)
+++ /trunk/expressoCalendar/setup/default_records.inc.php	(revision 5715)
@@ -24,5 +24,8 @@
 		//calendar_repeat
 		$oProc->query("ALTER TABLE calendar_repeat ADD CONSTRAINT fk_calendar_repeat_calendar_object FOREIGN KEY (object_id) REFERENCES calendar_object (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE;");
-	
+
+		//calendar_repeat_occurrence
+		$oProc->query("ALTER TABLE calendar_repeat_occurrence ADD CONSTRAINT fk_calendar_repeat_to_calendar_repeat_occurrence FOREIGN KEY (repeat_id) REFERENCES calendar_repeat (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE;");	
+
 		//calendar_signature
 		$oProc->query("ALTER TABLE calendar_signature ADD CONSTRAINT fk_calendar_signature_calendar_espec FOREIGN KEY (calendar_id) REFERENCES calendar (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE;");
Index: /trunk/expressoCalendar/setup/tables_current.inc.php
===================================================================
--- /trunk/expressoCalendar/setup/tables_current.inc.php	(revision 5592)
+++ /trunk/expressoCalendar/setup/tables_current.inc.php	(revision 5715)
@@ -215,5 +215,6 @@
                 'id' => array( 'type' => 'auto', 'nullable' => False),
                 'frequency' => array(  'type' => 'varchar','precision' => '20', 'nullable' => False),
-                'until' => array(  'type' => 'int', 'precision' => '8', 'nullable' => False),
+                'until' => array(  'type' => 'int', 'precision' => '8', 'nullable' => True),
+		'dtstart' => array(  'type' => 'bigint','precision' => '16', 'nullable' => True),
                 'count' => array(  'type' => 'int', 'precision' => '8', 'nullable' => True),
                 'object_id' => array(  'type' => 'int', 'precision' => '8', 'nullable' => False),
@@ -236,4 +237,30 @@
 		),
 
+	    'calendar_repeat_ranges' => array(
+            'fd' => array(
+                'id' => array( 'type' => 'auto', 'nullable' => False),
+                'range_start' => array(  'type' => 'bigint','precision' => '16', 'nullable' => False),
+                'range_end' => array(  'type' => 'bigint', 'precision' => '16', 'nullable' => False),
+                'user_info_id' => array(  'type' => 'bigint', 'precision' => '16', 'nullable' => False)
+            ),
+            'pk' => array('id'),
+            'fk' => array(),
+            'ix' => array(),
+            'uc' => array()
+		),
+
+	    'calendar_repeat_occurrence' => array(
+            'fd' => array(
+                'id' => array( 'type' => 'auto', 'nullable' => False),
+                'occurrence' => array(  'type' => 'bigint','precision' => '16', 'nullable' => False),
+                'repeat_id' => array(  'type' => 'int', 'precision' => '8', 'nullable' => False)
+            ),
+
+            'pk' => array('id'),
+            'fk' => array('repeat_id'),
+            'ix' => array(),
+            'uc' => array()
+		),
+
 		'calendar_signature' => array(
             'fd' => array(
Index: /trunk/expressoCalendar/setup/tables_update.inc.php
===================================================================
--- /trunk/expressoCalendar/setup/tables_update.inc.php	(revision 5651)
+++ /trunk/expressoCalendar/setup/tables_update.inc.php	(revision 5715)
@@ -33,3 +33,45 @@
         return $GLOBALS['setup_info']['expressoCalendar']['currentver'];
 	}
+
+	$test[] = '1.001';
+	function expressoCalendar_upgrade1_001() {
+
+		$oProc = $GLOBALS['phpgw_setup']->oProc;
+
+		$oProc->query("ALTER TABLE calendar_repeat ADD COLUMN dtstart bigint");
+		$oProc->query('ALTER TABLE calendar_repeat ALTER COLUMN until DROP NOT NULL');
+
+		$oProc->CreateTable('calendar_repeat_occurrence', array(
+				'fd' => array(
+				    'id' => array( 'type' => 'auto', 'nullable' => False),
+				    'occurrence' => array(  'type' => 'bigint','precision' => '16', 'nullable' => False),
+				    'repeat_id' => array(  'type' => 'int', 'precision' => '8', 'nullable' => False)
+				),
+
+				'pk' => array('id'),
+				'fk' => array('repeat_id'),
+				'ix' => array(),
+				'uc' => array()
+				)
+		);
+
+		$oProc->CreateTable('calendar_repeat_ranges', array(
+				'fd' => array(
+				    'id' => array( 'type' => 'auto', 'nullable' => False),
+				    'range_start' => array(  'type' => 'bigint','precision' => '16', 'nullable' => False),
+				    'range_end' => array(  'type' => 'bigint', 'precision' => '16', 'nullable' => False),
+				    'user_info_id' => array(  'type' => 'bigint', 'precision' => '16', 'nullable' => False)
+				),
+				'pk' => array('id'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				    )
+		);
+
+		$oProc->query("ALTER TABLE calendar_repeat_occurrence ADD CONSTRAINT fk_calendar_repeat_to_calendar_repeat_occurrence FOREIGN KEY (repeat_id) REFERENCES calendar_repeat (id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE;");	
+
+		$GLOBALS['setup_info']['expressoCalendar']['currentver'] = '1.002';
+        return $GLOBALS['setup_info']['expressoCalendar']['currentver'];
+	}
 ?>
Index: /trunk/expressoCalendar/setup/setup.inc.php
===================================================================
--- /trunk/expressoCalendar/setup/setup.inc.php	(revision 5617)
+++ /trunk/expressoCalendar/setup/setup.inc.php	(revision 5715)
@@ -13,24 +13,26 @@
 	$setup_info['expressoCalendar']['title']     	= 'Expresso Calendar';
 	/* Ao incrementar versão, não esquecer de declarar função do tables_update.inc.php*/
-	$setup_info['expressoCalendar']['version']   	= '1.001';
+	$setup_info['expressoCalendar']['version']   	= '1.002';
 	$setup_info['expressoCalendar']['app_order']	= 10;
         
-		$setup_info['expressoCalendar']['tables'][]		=  'attachment';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_attach';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_class'; 
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_alarm';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_ex_participant'; 
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_object'; 
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_object_type';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_participant';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_participant_status';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_permission';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_repeat';
-		$setup_info['expressoCalendar']['tables'][]		=  'calendar_signature';
-        $setup_info['expressoCalendar']['tables'][]		=  'calendar_signature_alarm';
-		$setup_info['expressoCalendar']['tables'][]		=  'module_preference';
-        $setup_info['expressoCalendar']['tables'][]		=  'calendar_to_calendar_object';
-				
+	$setup_info['expressoCalendar']['tables'][]		=  'attachment';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_attach';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_class'; 
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_alarm';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_ex_participant'; 
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_object'; 
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_object_type';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_participant';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_participant_status';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_permission';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_repeat';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_signature';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_signature_alarm';
+	$setup_info['expressoCalendar']['tables'][]		=  'module_preference';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_to_calendar_object';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_repeat_ranges';
+	$setup_info['expressoCalendar']['tables'][]		=  'calendar_repeat_occurrence';
+
 	$setup_info['expressoCalendar']['enable']		= 1;
 
Index: /trunk/prototype/services/iCal.php
===================================================================
--- /trunk/prototype/services/iCal.php	(revision 5682)
+++ /trunk/prototype/services/iCal.php	(revision 5715)
@@ -37,5 +37,5 @@
                     
                        $vevent = $ical->newComponent( 'vevent' );
-                        
+                                        
                        $vevent->setProperty( 'summary' , $v['summary'] );
                        $vevent->setProperty( 'description' , $v['description'] );
@@ -45,9 +45,36 @@
                        $timezone = new DateTimeZone('UTC');
                        $apTimezone = self::nomalizeTZID(( isset($v['timezone']) && $v['timezone'] != 'null' ) ? $v['timezone'] : $params['defaultTZI']);
-                         
+                       $apTimezoneOBJ = new DateTimeZone($apTimezone);
+                       
                        $sTime = new DateTime( '@'.(int)($v['startTime'] / 1000) , $timezone );                                    
-                       $sTime->setTimezone(new DateTimeZone($apTimezone));
+                       $sTime->setTimezone($apTimezoneOBJ);
                        $eTime = new DateTime( '@'.(int)($v['endTime'] / 1000) , $timezone );  
-                       $eTime->setTimezone(new DateTimeZone($apTimezone));
+                       $eTime->setTimezone($apTimezoneOBJ);
+                       
+                       if(isset($v['repeat']))
+                       {
+                           $repeat = array();
+                           
+                           foreach ($v['repeat'] as $ir => $rv) 
+                           {
+                               if($rv)
+                               {
+                                   if($ir == 'frequency')
+                                      $repeat['FREQ'] =  $rv;
+                                   else if($ir == 'endTime' )
+                                   {
+                                       $time = new DateTime( '@'.(int)($rv / 1000) , $timezone );                                    
+                                       $time->setTimezone($apTimezoneOBJ);
+                                       $repeat['until'] = $time->format(DATE_RFC822);
+                                   }
+                                   else if($ir == 'count')
+                                    $repeat[$ir] = $rv;
+                                   else if($ir !== 'schedulable' && $ir !== 'id' && $ir !== 'startTime')
+                                    $repeat[$ir] = explode(',', $rv);
+                               }
+                           }
+                          
+                           $vevent->setProperty('rrule' , $repeat);
+                       }
                        
                        if( isset($v['allDay']) && $v['allDay'] == 1 )
@@ -757,7 +784,14 @@
                     $repeat['schedulable'] = $eventID;
                     foreach($rrule as $i => $v)
-                       $repeat[strtolower($i)] = $v;
-
-                    //$interation['repeat://'.$repeatID] = $repeat;
+                    {
+                        if(strtolower($i) == 'freq')
+                            $repeat['frequency'] = $v;
+                        else if(strtolower($i) == 'until')
+                            $repeat['endTime'] = $v;
+                        else
+                            $repeat[strtolower($i)] = $v;
+                    }
+                    
+                    $interation['repeat://'.$repeatID] = $repeat;
                 }
 
Index: /trunk/prototype/Sync.php
===================================================================
--- /trunk/prototype/Sync.php	(revision 5514)
+++ /trunk/prototype/Sync.php	(revision 5715)
@@ -64,5 +64,5 @@
                     if( isset( $dt[$linkName] ) )
                     {
-                            if( $notArray = Controller::isConcept( $concept, $linkName ) )
+                            if( $notArray = Controller::hasOne( $concept, $linkName ) )
                                     $dt[$linkName] = array( $dt[$linkName] );
 
@@ -148,5 +148,5 @@
 
 		  $return[ $oldURI ] = !$tx['rollback'] ? $dt ? 
-				       array( 'id' => $tx['id'] ) : false : 'ROLLBACK';;
+				       array( 'id' => $tx['id'] ) : false : 'ROLLBACK';
 	  }
     }
Index: /trunk/prototype/config/repeat.ini
===================================================================
--- /trunk/prototype/config/repeat.ini	(revision 5514)
+++ /trunk/prototype/config/repeat.ini	(revision 5715)
@@ -1,5 +1,46 @@
 service = PostgreSQL
+PostgreSQL.concept = calendar_repeat
 
 [model.depends]
 schedulable = schedulable.repeat
 
+; [model.hasMany]
+; occurrences = repeatOccurrence.repeat
+
+[before.create]
+prepareRepeat = modules/calendar/interceptors/DBMapping.php
+; 
+[before.update]
+prepareRepeat = modules/calendar/interceptors/DBMapping.php
+
+[after.create]
+saveOccurrences = modules/calendar/interceptors/DBMapping.php
+
+[after.update]
+saveOccurrences = modules/calendar/interceptors/DBMapping.php
+
+[after.find]
+deepnessRepeat = modules/calendar/interceptors/DBMapping.php
+;reprepareRepeat = modules/calendar/interceptors/DBMapping.php
+
+[after.read]
+deepnessRepeat = modules/calendar/interceptors/DBMapping.php
+;reprepareRepeat = modules/calendar/interceptors/DBMapping.php
+
+[PostgreSQL.mapping]
+wkst = wkst
+byweekno = byweekno
+byminute = byminute
+bysecond = bysecond
+byyearday = byyearday
+bymonthday = bymonthday
+bysetpos = bysetpos
+byday = byday
+byhour = byhour
+interval = interval
+frequency = frequency
+endTime = until
+schedulable = object_id
+id = id
+count = count
+startTime = dtstart
Index: /trunk/prototype/config/schedulableToAttachment.ini
===================================================================
--- /trunk/prototype/config/schedulableToAttachment.ini	(revision 5514)
+++ /trunk/prototype/config/schedulableToAttachment.ini	(revision 5715)
@@ -2,5 +2,5 @@
 PostgreSQL.concept = calendar_attach
 
-[model.hasOne]
+[model.depends]
 schedulable = schedulable.attachments
 
Index: /trunk/prototype/config/repeatOccurrence.ini
===================================================================
--- /trunk/prototype/config/repeatOccurrence.ini	(revision 5715)
+++ /trunk/prototype/config/repeatOccurrence.ini	(revision 5715)
@@ -0,0 +1,10 @@
+service = PostgreSQL
+PostgreSQL.concept = calendar_repeat_occurrence
+
+[after.find]
+deepnessFindRepeatOccurrence = modules/calendar/interceptors/DBMapping.php
+
+[PostgreSQL.mapping]
+occurrence = occurrence
+repeat = repeat_id
+id = id
Index: /trunk/prototype/config/repeatRange.ini
===================================================================
--- /trunk/prototype/config/repeatRange.ini	(revision 5715)
+++ /trunk/prototype/config/repeatRange.ini	(revision 5715)
@@ -0,0 +1,8 @@
+service = PostgreSQL
+PostgreSQL.concept = calendar_repeat_ranges
+
+[PostgreSQL.mapping]
+rangeStart = range_start
+rangeEnd = range_end
+user = user_info_id
+id = id
Index: /trunk/prototype/config/schedulable.ini
===================================================================
--- /trunk/prototype/config/schedulable.ini	(revision 5514)
+++ /trunk/prototype/config/schedulable.ini	(revision 5715)
@@ -48,5 +48,5 @@
 transparent = transp
 class = class_id
-repeat = repeat
+;repeat = repeat
 rangeStart = range_start
 rangeEnd = range_end
Index: /trunk/prototype/config/attachment.ini
===================================================================
--- /trunk/prototype/config/attachment.ini	(revision 5592)
+++ /trunk/prototype/config/attachment.ini	(revision 5715)
@@ -1,7 +1,4 @@
 service = PostgreSQL
 PostgreSQL.concept = attachment
-
-[model.hasOne]
-schedulable = schedulable.attachments
 
 [before.create]
Index: /trunk/prototype/links.php
===================================================================
--- /trunk/prototype/links.php	(revision 5514)
+++ /trunk/prototype/links.php	(revision 5715)
@@ -16,4 +16,5 @@
     $concepts = array();
     $nestedLinks = array();
+    $hasOne = array();
 
     foreach( $link as $linkName => $linkTarget )
@@ -22,8 +23,11 @@
 	    $concepts[ $linkName ] = true;
 
+	 if( Controller::hasOne( $concept, $linkName ) )
+	    $hasOne[ $linkName ] = true;
+
 	  $nestedLinks[ $linkName ] = Controller::links( $concept, $linkName );
     }
 
-    $return[ $target ] = array( 'concepts' => $concepts, 'links' => $link, 'nestedLinks' => $nestedLinks );
+    $return[ $target ] = array( 'concepts' => $concepts, 'links' => $link, 'nestedLinks' => $nestedLinks, 'hasOne' => $hasOne );
 }
 
Index: /trunk/prototype/modules/calendar/export.php
===================================================================
--- /trunk/prototype/modules/calendar/export.php	(revision 5514)
+++ /trunk/prototype/modules/calendar/export.php	(revision 5715)
@@ -54,5 +54,11 @@
 		$event['attachments'] = Controller::find( array( 'concept' => 'attachment' ) , false ,array( 'filter' => array('IN', 'id' , $attachments) )); 
 	}
-		
+        
+    $repeat = Controller::find( array( 'concept' => 'repeat' ) , false ,array( 'filter' => array('=', 'schedulable'  ,  $event['id']) ));    
+        
+    if(is_array($repeat))
+        $event['repeat'] = $repeat[0];
+
+     
     $ics = Controller::format( array( 'service' => 'iCal' ) , array($event) , array('defaultTZI' => $event['timezone']) );
     
Index: /trunk/prototype/modules/calendar/js/calendar.codecs.js
===================================================================
--- /trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 5652)
+++ /trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 5715)
@@ -2,5 +2,5 @@
   
     init: function(){
-		this.moduleName = 'expressoCalendar';
+		this.moduleName = 'expressoCalendar'; 
 		this.me = DataLayer.dispatch( "me" );
 		
@@ -9,5 +9,5 @@
 		this.isDaylightSaving = Timezone.daylightSaving;
 		this.load();      
-    },
+    },             
   
     load: function(){
@@ -564,8 +564,9 @@
 				return returns;
 			};
-						
+								
 		    return {
 			    "class": objEvent["class"],
 			    id: objEvent.id,
+			    repeat: encodeRepeat( objEvent.repeat ),
 			    location: objEvent.location,
 			    category: objEvent.category,
@@ -605,7 +606,5 @@
 							receiveNotification : attend.receiveNotification,
 							alarms : $.map(attend.alarms || [], function( alarm ){
-								//TODO - Atualizar cach cliente em conceito aninhados de camada 2
-								var alarmEvent = DataLayer.get('alarm', alarm)
-								return !!alarmEvent ? alarmEvent: (null);
+								return DataLayer.get('alarm', alarm);
 							})
 						};
@@ -643,4 +642,5 @@
 			    me: !!participantInfo.user ? DataLayer.merge(participantInfo.user, me) : DataLayer.merge(this.isShared ? this.organizer :  me, {acl:  !this.isShared ? 'rowi' : Calendar.signatureOf[objEvent.calendar].permission.aclValues, delegatedFrom: 0, receiveNotification: 1}),
 				delegatedFrom: delegatedFrom,
+				
 				statusParticipants: statusParticipants
 			};
@@ -650,5 +650,85 @@
 });
 
-
+function decodeRepeat ( form ) {
+
+	var patati = {};
+	
+	if( form.repeatId )
+	    patati['id'] = form.repeatId;
+
+	patati['frequency'] = form.frequency;
+
+ 	patati['bymonthday'] = patati['byyearday'] = patati['byday'] = '';
+	
+	patati['interval'] = patati['endTime'] = patati['count'] = patati['startTime'] = 0;
+	
+	if( form.frequency === 'none' )
+	    return( patati );
+	
+	var day = [];
+
+	$("input[type=checkbox][name='repeatweekly[]']:checked").each(function() { 
+		day[ day.length ] = $(this).val();
+	});
+
+	patati['byday'] = day.join(',');
+
+	var formatString = ( typeof form.allDay !== "undefined" && !!form.allDay )? User.preferences.dateFormat+" HH:mm" : User.preferences.dateFormat + " " + User.preferences.hourFormat;
+
+	var date = Date.parseExact( form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).add( { days: 1 } ).toString('yyyy-MM-dd HH:mm:00');
+	
+	patati['startTime'] = date.toString('yyyy-MM-dd HH:mm:00');
+	
+	if( !patati['byday'] )
+	      switch(form.frequency) {
+	      case 'weekly':      
+		      break;
+	      case 'daily':
+		      break;
+	      case 'monthly':
+		      patati['bymonthday'] = date.getDate();
+		      break;
+	      case 'yearly':
+		      patati['byyearday'] = date.getDayOfYear();
+		      break;
+	      default :
+		      return patati;
+	      }
+
+	if (($(".endRepeat").val() == 'occurrences')) 
+		patati['count'] = $(".occurrencesEnd").val(); 
+	
+	if (($(".endRepeat").val() == 'customDate'))
+		patati['endTime'] = Date.parseExact( $(".customDateEnd").val() + (!!form.allDay ? " 00:00": " "+$.trim(form.endHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00');
+	
+	patati['interval']  = $(".eventInterval").val();
+
+	/**
+	wkst = [ 'MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU' ]
+	weekno = number
+	minute = number
+	second = number
+	yearday = number
+	monthday = number
+	setpos = number
+	day = number
+	hour = number
+	interval = number
+	frequency = [ 'monthly', 'daily', 'weekly', 'yearly', 'hourly', 'minutely', 'secondly' ]
+	endTime = milliseconds
+    */	  
+    return( patati );
+      
+}
+
+
+
+function encodeRepeat( repeat ){
+  
+	if( !repeat )
+	    return( false );
+
+	return DataLayer.get( 'repeat', repeat );
+}
 
 DataLayer.codec( "schedulable", "detail", {
@@ -674,5 +754,5 @@
 				  startTime: Date.parseExact(form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00'),
 				  endTime:  Date.parseExact(form.endDate + ( !!form.allDay ? " 00:00": " "+$.trim(form.endHour)), formatString ).toString('yyyy-MM-dd HH:mm:00'),  //+ (!!form.allDay ? 86400000 : 0) ,
-				  allDay: ( !!form.allDay ? 1 : 0 ),
+				  allDay: ( !!form.allDay ? 1 : 0 ),       
 			      id: form.idEvent,
 			      location: form.location,
@@ -685,4 +765,5 @@
 						return {attachment: attachment}
 				  }),
+			      repeat: this.decodeRepeat( form ),
 			      participants: $.map( form.attendee || [], function( attendee, i ){
 
@@ -722,45 +803,61 @@
     },
 
+
     encoder: function( evtObj ){
 	
-	if(!(!!evtObj))
-		return undefined;
-
-	var notArray = false;
-      
-	if( notArray = $.type(evtObj) !== "array" )
-	    evtObj = [ evtObj ];
-
-	var pref = User.preferences;
-
-	var res =  DataLayer.encode('schedulable:preview', evtObj);
-
-	if( !notArray ){
-	    var dates = {};
-
-	    for (var i=0; i < res.length; i++) {
-
-		    var startDate = Date.parseExact( res[i]['startDate'], User.preferences.dateFormat );
-		    var endDate   = Date.parseExact( res[i]['endDate'], User.preferences.dateFormat );
-
-		    var counter   = startDate.clone();
-
-		    while (counter.compareTo(startDate) == 0) {
-
-			    if (!dates[counter.toString(User.preferences.dateFormat)]) 
-					dates[counter.toString(User.preferences.dateFormat)] = { startDate:false, events:[] };
-			    if (!dates[counter.toString(User.preferences.dateFormat)].startDate) 
-					dates[counter.toString(User.preferences.dateFormat)].startDate = counter.toString(User.preferences.dateFormat);
-
-			    dates[counter.toString(User.preferences.dateFormat)].events.push(res[i]);
-			    counter.addDays(-1);
-		    } 
-	    }
-	    res = { events_list: dates,
-				count : res.length
-			};
-	}
-
-	return notArray ? res[0] : res;
+		if(!(!!evtObj))
+			return undefined;
+
+		var notArray = false;
+		  
+		if( notArray = $.type(evtObj) !== "array" )
+			evtObj = [ evtObj ];
+
+		var pref = User.preferences;
+
+		var res =  DataLayer.encode('schedulable:preview', evtObj);
+
+		if( !notArray ){
+			var dates = {};
+
+			for (var i=0; i < res.length; i++) {
+			  
+				var startDate = Date.parseExact( res[i]['startDate'], User.preferences.dateFormat );
+				var endDate   = Date.parseExact( res[i]['endDate'], User.preferences.dateFormat );
+			  
+				var duration = parseInt( endDate.getTime() ) - parseInt( startDate.getTime() );
+		
+				var occurrences = [ startDate.getTime() ];
+				
+				if( res[i].occurrences )
+				{
+				    occurrences = res[i].occurrences;
+				}
+
+				for( var ii = 0; ii < occurrences.length; ii++ )
+				{
+				    var currentDate = new Date( occurrences[ii] );
+				    var counter = currentDate.clone();
+				    
+				    var res2 = $.extend( {}, res[i], {'startDate': currentDate.toString( User.preferences.dateFormat ), 'endDate': new Date( occurrences[ii] + duration ).toString( User.preferences.dateFormat ) } );
+				  
+				    while (counter.compareTo( currentDate ) == 0) {
+
+					    if (!dates[counter.toString(User.preferences.dateFormat)]) 
+						    dates[counter.toString(User.preferences.dateFormat)] = { startDate:false, events:[] };
+					    if (!dates[counter.toString(User.preferences.dateFormat)].startDate) 
+						    dates[counter.toString(User.preferences.dateFormat)].startDate = counter.toString(User.preferences.dateFormat);
+
+					    dates[counter.toString(User.preferences.dateFormat)].events.push(res2);
+					    counter.addDays(-1);
+				    }      
+				}
+			}
+			res = { events_list: dates,
+					count : res.length
+				};
+		}
+
+		return notArray ? res[0] : res;
     }
 
@@ -823,89 +920,6 @@
 	    return( false );
 
-//       if( notArray = $.type(evtObj) !== "array" )
-// 	  evtObj = [ evtObj ];
-// 	alert( evtObj );
 	var filtered = evtObj;
-	
-	// repeat:{
-// 	  frequency: "weekly",
-// 	  endTime: Date.parse("+10 days").getTime(),
-// 	  interval: 3,
-// 	  byday: 3,
-// 	  bysecond: 3,
-// 	  byminute: 3,
-// 	  bymonthday: 3,
-// 	  byyearday: 3,
-// 	  byweekno: 3,
-// 	  bysetpos: 3,
-// 	  wkst: "monday"/*,
-// 	  duration: true*/
-//       }
-
-// 	$.each(evtObj, function( index, evt ){
-
-// 		alert( dump(!!evt.repeat) );
-
-// 		if( evt && !!evt.repeat && (evt.startTime < filter.end || (evt.repeat.endTime || 0) > filter.start ) )
-// 		{
-// // 		    var interval = evt.repeat.interval;
 // 
-// 		    var current = new Date( evt.startTime );
-// 		    var begin = new Date( filter.start );
-// 		    var end = new Date( filter.end );
-// 		    var offset = evt.endTime - evt.startTime;
-// 
-// 		    var ocurrence = [];
-// 
-// 		    while( Date.compare( current, begin ) !== 1 )
-// 			current = current.parse( "+" + evt.repeat.interval + " " + frequency + "s" );
-// 
-// 		    while( current.before( end ) && (ocurrence[ ocurrence.length ] = current) )
-// 			current = current.parse( "+" + evt.repeat.interval + " " + frequency + "s" );
-// 
-// 		    for( var i = 0; i < ocurrences.length; i++ )
-// 			filtered[ filtered.length ] = { URI: evt.URI,
-// 							summary: evt.summary,
-// 							start: new Date( ocurrences[i] ),
-// 							end: new Date( ocurrences[i] + offset ),
-// 							allDay: evt.allDay };
-// 
-// // 		    switch( evt.repeat.frequency )
-// // 		    {
-// // 		      case "yearly":   interval *= 12;
-// // 		      case "monthly":  interval *= 30; //TODO: get the month variant
-// // 		      case "weekly":   interval *= 7;
-// // 		      case "daily":    interval *= 24;
-// // 		      case "hourly":   interval *= 60;
-// // 		      case "minutely": interval *= 60; 
-// // 		      case "secondly": interval *= 1000;
-// // 		    }
-// // 		  
-// // 		    var rest = ( filter.start - evt.startTime ) % interval;
-// // 
-// // 		    var offset = evt.endTime - evt.startTime;
-// // 
-// // 		    if( rest < offset )
-// // 		    {
-// // 			var freq = Math.floor( offset - rest / interval );
-// // 
-// // 			
-// // 
-// // 			for( var i = 0; i < freq; i++ )
-// // 			{
-// // 			     var ocurrence = filter.start + rest + ( interval * i );
-// // 
-// // 			     
-// // 			}
-// // 
-// // 			
-// // 		    }
-// 		}
-
-// 		if( parseInt( evt.endTime ) > filter[1][0][2] || parseInt( evt.startTime ) < filter[1][1][2] )
-// 		    filtered[ filtered.length ] = evt;
-// 
-// 	});
-
 	var grouped = {};
 
@@ -922,5 +936,5 @@
 		var calendar = DataLayer.get('calendar', evt.calendar);
 		
-		var eventEditable = function(idEvent){
+		var eventEditable = function(idEvent, isRecurrence){
 			if(Calendar.signatureOf[calendar.id].isOwner == "1"){
 				var attendee = {};
@@ -928,7 +942,7 @@
 					attendee = DataLayer.get('participant', evt.participants[i]);
 						if(attendee.user == User.me.id)
-							return (attendee.acl.indexOf('w') >= 0 || attendee.acl.indexOf('o') >= 0 ) ? {selectable: true, className: 'fullcalendar-context-menu  event-id-'+idEvent} : {editable: false, selectable: true ,className: 'blocked-event-permision  fullcalendar-not-context-menu event-id-'+idEvent};
+							return (attendee.acl.indexOf('w') >= 0 || attendee.acl.indexOf('o') >= 0 ) ? {selectable: true, className: 'fullcalendar-context-menu  event-id-'+idEvent, editable: !isRecurrence} : { editable: false, selectable: true ,className: 'blocked-event-permision  fullcalendar-not-context-menu event-id-'+idEvent};
 				}
-				return {editable: false, className: 'blocked-event-permision  fullcalendar-not-context-menu event-id-'+idEvent,  selectable: true};
+				return {editable: false, className: 'blocked-event-permision  fullcalendar-not-context-menu event-id-'+idEvent,  selectable: true, disableDragging: isRecurrence };
 			}
 			else{
@@ -943,5 +957,5 @@
 				}				
 				return DataLayer.merge({
-					editable: aclSignature.acl['write'],
+					editable: aclSignature.acl['write'] && !isRecurrence,
 					disableResizing : (((aclSignature.acl['busy'] && !aclSignature.acl['write']) || (!aclSignature.acl['write'] && aclSignature.acl['read'])) ? true : false),
 					disableDragging  : (((aclSignature.acl['busy'] && !aclSignature.acl['write']) || (!aclSignature.acl['write'] && aclSignature.acl['read'])) ? true: false),
@@ -951,10 +965,21 @@
 			
 		}
+		
+		var duration = parseInt( evt.endTime ) - parseInt( evt.startTime ), isRepeat = false;
+		
+		var occurrences = [ evt.startTime ];
+		
+		if( evt.occurrences )
+		{
+		    isRepeat = true;
+		    occurrences = evt.occurrences;
+		}
 		  
-		grouped[ evt.calendar ].push( DataLayer.merge({ id: evt.URI || evt.id,
-						title: Encoder.htmlDecode(evt.summary),
-						start: Timezone.getDateCalendar(new Date(parseInt( evt.startTime )), calendar.timezone,  !!evt.DayLigth ? evt.DayLigth.calendar.startTime : Timezone.daylightSaving),
-						end:   Timezone.getDateCalendar(new Date(parseInt( evt.endTime ) - (!!parseInt(evt.allDay) ? 86400000 : 0)), calendar.timezone, !!evt.DayLigth ? evt.DayLigth.calendar.startTime : Timezone.daylightSaving),
-						allDay: parseInt( evt.allDay ) }, eventEditable(evt.id) ) );
+		for( var i = 0; i < occurrences.length; i++ )
+		    grouped[ evt.calendar ].push( DataLayer.merge({ id: evt.URI || evt.id,
+						    title: Encoder.htmlDecode(evt.summary),
+						    start: Timezone.getDateCalendar(new Date( parseInt( occurrences[i] ) ), calendar.timezone,  !!evt.DayLigth ? evt.DayLigth.calendar.startTime : Timezone.daylightSaving),
+						    end:   Timezone.getDateCalendar(new Date( parseInt( occurrences[i] ) + duration - (!!parseInt(evt.allDay) ? 86400000 : 0)), calendar.timezone, !!evt.DayLigth ? evt.DayLigth.calendar.startTime : Timezone.daylightSaving),
+						    allDay: parseInt( evt.allDay ) }, eventEditable(evt.id, isRepeat ) ) );
 	});
 
